﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using System.ComponentModel;

namespace WpfApplication1
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		ObservableCollection<TestClass> collection;
		DataTable tab;

		public Window1()
		{
			InitializeComponent();


			#region Building Collection
			collection = new ObservableCollection<TestClass>();
			collection.Add(new TestClass() { Test1 = false, Test2 = false, Test3 = false });
			collection.Add(new TestClass() { Test1 = true, Test2 = false, Test3 = true });

			foreach (TestClass tc in collection) { tc.PropertyChanged += new PropertyChangedEventHandler(collection_PropertyChanged); } 
			#endregion


			#region Building DataTable
			tab = new DataTable();
			tab.Columns.Add(new DataColumn("test1", typeof(bool)));
			tab.Columns.Add(new DataColumn("test2", typeof(bool)));
			tab.Columns.Add(new DataColumn("test3", typeof(bool)));

			DataRow row = tab.NewRow();

			row["test1"] = true;
			row["test2"] = true;
			row["test3"] = true;

			tab.Rows.Add(row);


			row = tab.NewRow();

			row["test1"] = false;
			row["test2"] = false;
			row["test3"] = false;

			tab.Rows.Add(row); 
			#endregion

			//or try with DataTable
			//this.xamDataGrid1.DataSource = tab.DefaultView;

			this.xamDataGrid1.DataSource = collection;

		}

		private void collection_PropertyChanged(object sender, PropertyChangedEventArgs e)
		{
			txtOutput.Text += "\n" + e.PropertyName;

		}
	}

	class TestClass : INotifyPropertyChanged
	{
		private bool test1;

		public bool Test1
		{
			get { return test1; }
			set
			{
				test1 = value;
				Notify("Test1");
			}
		}
		private bool test2;

		public bool Test2
		{
			get { return test2; }
			set
			{
				test2 = value;
				Notify("Test2");
			}
		}
		private bool test3;

		public bool Test3
		{
			get { return test3; }
			set 
			{ 
				test3 = value;
				Notify("Test3");
			}
		}

		#region Helpers
		private void Notify(string propertyName)
		{
			if (PropertyChanged != null)
			{
				PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
		#endregion

		#region INotifyPropertyChanged Members

		public event PropertyChangedEventHandler PropertyChanged;

		#endregion
	}
}
